//+------------------------------------------------------------------+
//|                                                       NoLoss.mq4 |
//|                              Copyright  2012, Khlistov Vladimir |
//|                                         http://cmillion.narod.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Khlistov Vladimir"
#property link      "http://cmillion.narod.ru"
#property indicator_chart_window
extern color ColorMarket = C'47,47,255';
extern color ColorSL     = Lime;
extern int   Width     = 2;
extern color ColorBuy  = Blue;
extern int   WidthBuy  = 1;
extern color ColorSell = Red;
extern int   WidthSell = 1;
extern bool  DrowPriceLabels = false;
extern bool  DrowLotLabels = false;
extern int   MaxSpread = 20;
extern int   Magic     = -1; // -1,       ,    
extern int   PairsCount = 9;
extern int   Leverage = 100;
extern double   Risk = 0.2;
//+------------------------------------------------------------------+
int start()
{
   double profit, Profit, ProfitS, ProfitB;
   int b,s,tip,bo,so;
   double price,price_b,price_s,lot,lot_s,lot_b,price_bo,price_so,lot_so,lot_bo,NLb,NLs,NL;
   double TICKVALUE=MarketInfo(Symbol(),MODE_TICKVALUE);
   double LOTSIZE = MarketInfo(Symbol(),MODE_LOTSIZE);
   for (int i=0; i<OrdersTotal(); i++)
   {  
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
      {  
         if (OrderSymbol()==Symbol() && (Magic == OrderMagicNumber() || Magic == -1))
         {
            profit = OrderProfit()+OrderSwap()+OrderCommission();
            Profit += profit;
            price = OrderOpenPrice();
            lot = OrderLots();
            tip = OrderType();
            if (tip==OP_BUY ) 
            {
               ProfitB += profit;
               price_b += price*lot;
               b++;  
               lot_b+=lot;
            }
            if (tip==OP_SELL) 
            {
               ProfitS += profit;
               price_s += price*lot;
               s++;  
               lot_s+=lot;
            }
            if (DrowLotLabels) drawtext(OrderTicket(),OrderOpenPrice(),lot,colorType(tip));
            if (tip==OP_BUYSTOP || tip==OP_BUYLIMIT) 
            {
               price_bo += price*lot;
               lot_bo+=lot;
               bo++;
            }
            if (tip==OP_SELLSTOP || tip==OP_SELLLIMIT) 
            {
               price_so += price*lot;
               lot_so+=lot;
               so++;
            }
         }  
      }  
   }
   ObjectDelete("NoLoss__NLb");
   if (b!=0) 
   {  
      NLb = price_b/lot_b;
      ObjectCreate("NoLoss__NLb",OBJ_ARROW,0,Time[0],NLb,0,0,0,0);                     
      ObjectSet   ("NoLoss__NLb",OBJPROP_ARROWCODE,6);
      ObjectSet   ("NoLoss__NLb",OBJPROP_COLOR, ColorBuy);
      ObjectSet   ("NoLoss__NLb",OBJPROP_WIDTH, WidthBuy);
   }
   ObjectDelete("NoLoss__NLs");
   if (s!=0) 
   {  
      NLs = price_s/lot_s;
      ObjectCreate("NoLoss__NLs",OBJ_ARROW,0,Time[0],NLs,0,0,0,0);                     
      ObjectSet   ("NoLoss__NLs",OBJPROP_ARROWCODE,6);
      ObjectSet   ("NoLoss__NLs",OBJPROP_COLOR, ColorSell);
      ObjectSet   ("NoLoss__NLs",OBJPROP_WIDTH, WidthSell);
   }
//   ObjectDelete("NoLoss__NL");
//   if (b!=0 && s!=0 && lot_b!=lot_s) 
//   {  
//      NL = NormalizeDouble(Bid - Profit/TICKVALUE/(lot_b-lot_s)*Point,Digits);
//      ObjectCreate("NoLoss__NL",OBJ_ARROW,0,Time[0],NL,0,0,0,0);                     
//      ObjectSet   ("NoLoss__NL",OBJPROP_ARROWCODE,6);
//      ObjectSet   ("NoLoss__NL",OBJPROP_COLOR, ColorMarket);
//      ObjectSet   ("NoLoss__NL",OBJPROP_WIDTH, Width);
//   }
//   ObjectDelete("NoLoss_ ");
//   if (bo+b!=0 && so+s!=0 && lot_b+lot_bo!=lot_s+lot_so) 
//   {  
//      NL = NormalizeDouble((price_bo+price_b-price_so-price_s)/(lot_b+lot_bo-lot_s-lot_so),Digits);
//      ObjectCreate("NoLoss_ ",OBJ_ARROW,0,Time[0],NL,0,0,0,0);                     
//      ObjectSet   ("NoLoss_ ",OBJPROP_ARROWCODE,6);
//      ObjectSet   ("NoLoss_ ",OBJPROP_COLOR, ColorSL);
//      ObjectSet   ("NoLoss_ ",OBJPROP_WIDTH, Width);
//   }
   
   //DrawLABEL("NoLoss__TIME",3,5,15,Gray,TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
   //DrawLABEL("NoLoss__1",3,5,30,colorPrice(ProfitB),StringConcatenate("Buy ",b,"  Profit ",DoubleToStr(ProfitB,2),"  Lot ",DoubleToStr(lot_b,2)));
   //DrawLABEL("NoLoss__2",3,5,45,colorPrice(ProfitS),StringConcatenate("Sell ",s,"  Profit ",DoubleToStr(ProfitS,2),"  Lot ",DoubleToStr(lot_s,2)));
   //DrawLABEL("NoLoss__b",3,5,60,colorPriceo(lot_so),StringConcatenate(" sell ",so,"   lot ",DoubleToStr(lot_so,2)));
   //DrawLABEL("NoLoss__s",3,5,75,colorPriceo(lot_bo),StringConcatenate(" buy ",bo,"   lot ",DoubleToStr(lot_bo,2)));

   DrawLABEL("NoLoss__1",3,10,10,colorPrice(ProfitB),StringConcatenate("Buy ",b,"  Profit ",DoubleToStr(ProfitB,2),"  Lot ",DoubleToStr(lot_b,2)));
   DrawLABEL("NoLoss__2",3,10,25,colorPrice(ProfitS),StringConcatenate("Sell ",s,"  Profit ",DoubleToStr(ProfitS,2),"  Lot ",DoubleToStr(lot_s,2)));
   DrawLABEL("NoLoss__b",3,10,40,colorPriceo(lot_so),StringConcatenate(" sell ",so,"  Lot ",DoubleToStr(lot_so,2)));
   DrawLABEL("NoLoss__s",3,10,55,colorPriceo(lot_bo),StringConcatenate(" buy ",bo,"  Lot ",DoubleToStr(lot_bo,2)));
   DrawLABEL("NoLoss__separator1",3,10,70,DimGray,"------------------------------------");
   ShowSwaps();
   ShowSpread();
   DrawLABEL("NoLoss__separator2",3,10,130,DimGray,"------------------------------------");
   ShowRecommendedLot();

}

//+------------------------------------------------------------------+
void ShowSwaps()
{

  double swaplong,swapshort;
  swaplong=NormalizeDouble(MarketInfo(Symbol(),18),2);
  swapshort=NormalizeDouble(MarketInfo(Symbol(),19),2);
  
  if (swaplong>=0)
    {
      DrawLABEL("NoLoss__SwapBuy",3,10,85,ColorMarket,StringConcatenate(" buy    ", DoubleToStr( swaplong ,2)));
    }
  else
    {
      DrawLABEL("NoLoss__SwapBuy",3,10,85,DimGray,StringConcatenate(" buy  - ", DoubleToStr(-swaplong ,2)));
    }
    
  if (swapshort>=0)
    {
      DrawLABEL("NoLoss__SwapSell",3,10,100,ColorMarket,StringConcatenate(" sell    ", DoubleToStr( swapshort ,2)));
    }
  else
    {
      DrawLABEL("NoLoss__SwapSell",3,10,100,DimGray,StringConcatenate(" sell  - ", DoubleToStr(-swapshort ,2)));
    }
    
}

//-----------------------------------------------------------------------------/
void ShowRecommendedLot()
{
  double _acc_equity, _RecLot;
  string text = "RecLot    "; 
  
  _acc_equity=AccountEquity();
  _RecLot=((_acc_equity / PairsCount) /Leverage)*Risk/10;
  text = text + DoubleToStr(_RecLot ,2);
    
  DrawLABEL("NoLoss__RecLot",3,10,145,DarkGreen,text);
}

//-----------------------------------------------------------------------------/
void ShowSpread()
{
  int spread;
  spread=MarketInfo(Symbol(),13);
  string text = "Spread    "; 
  if (spread<10) text = text + DoubleToStr( spread ,2);
  else
  {
   if (spread<100) text = text + DoubleToStr( spread ,1);
   else text = text + DoubleToStr( spread ,0);
  }


  if (spread>MaxSpread)
    {
      DrawLABEL("NoLoss__Spread",3,10,115,Red,text);
    }
  else
    {
      DrawLABEL("NoLoss__Spread",3,10,115,DimGray,text);
    }
}

//+------------------------------------------------------------------+
int deinit()
{
   remove_objects("NoLoss_");
   return(0);  
}
//+------------------------------------------------------------------+
int drawtext(string NameLine, double Y1, double l,color c)
{
   NameLine=StringConcatenate("NoLoss__",NameLine);
   ObjectDelete (NameLine);
   ObjectCreate (NameLine, OBJ_TEXT,0,Time[WindowFirstVisibleBar()-WindowFirstVisibleBar()/10],Y1,0,0,0,0);
   ObjectSetText(NameLine, DoubleToStr(l,2),8,"Arial");
   ObjectSet    (NameLine, OBJPROP_COLOR, c);
}
//--------------------------------------------------------------------
void DrawLABEL(string name, int CORNER, int X, int Y, color clr, string Name)
{
   if (ObjectFind(name)==-1)
   {
      ObjectCreate(name, OBJ_LABEL, 0, 0, 0);
      ObjectSet(name, OBJPROP_CORNER, CORNER);
      ObjectSet(name, OBJPROP_XDISTANCE, X);
      ObjectSet(name, OBJPROP_YDISTANCE, Y);
   }
   ObjectSetText(name,Name,10,"Arial",clr);
}
//+------------------------------------------------------------------+
/*string StrOrdersType(int t) 
{ 
   if (t==OP_BUY) return("Buy");
   if (t==OP_SELL) return("Sell");
   if (t==OP_BUYLIMIT) return("BuyLimit");
   if (t==OP_SELLLIMIT) return("SellLimit");
   if (t==OP_BUYSTOP) return("BuyStop");
   if (t==OP_SELLSTOP) return("SellStop");
} 
//-------------------------------------------------------------------- */
color colorType(int t) 
{ 
   if (t==OP_BUY) return(ColorBuy);
   if (t==OP_SELL) return(ColorSell);
   if (t==OP_BUYLIMIT) return(ColorBuy);
   if (t==OP_SELLLIMIT) return(ColorSell);
   if (t==OP_BUYSTOP) return(ColorBuy);
   if (t==OP_SELLSTOP) return(ColorSell);
} 
//-------------------------------------------------------------------- 
color colorPriceo(double p) 
{ 
   if (p==0) return(DimGray);
   if (p>0) return(ColorSL);
   if (p<0) return(Red);
} 
//-------------------------------------------------------------------- 
color colorPrice(double p) 
{ 
   if (p==0) return(DimGray);
   if (p>0) return(ColorMarket);
   if (p<0) return(Red);
} 
//-------------------------------------------------------------------- 
int remove_objects(string PreName)                                     //e e e  PreName
{
   for(int k=ObjectsTotal()-1; k>=0; k--) 
     {
      string Obj_Name=ObjectName(k);                           // pre  e
      string Head=StringSubstr(Obj_Name,0,StringLen(PreName)); // ee pere 
 
      if (Head==PreName)// e e, ..
         {
         ObjectDelete(Obj_Name);
         }                  
     }
   return(0);
}
//-------------------------------------------------------------------- */


